<?php
namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Teknisa\Model\Util\NovoCodigo;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;

class crmSLALembreteNotificacao extends TeknisaCrud {
    
    protected $dataSourceName = '';
    protected $entityManager;
    protected $connection;
    protected $environment;

    
    public function __construct ($crudService, $parameterBag, $entityManager, $environment)
    {
        $this->entityManager = $entityManager;
        $this->connection    = $entityManager->getConnection();
        $this->environment   = $environment;

        parent::__construct($crudService, $parameterBag);
    }
    
    public function saveOperNotResposta($RESP){
        $operadores = $RESP['OPERADORESP'];
        
        
        if(count($operadores) > 0){
            foreach($operadores as $operador) {
            $insertResposta = "INSERT INTO CRM_ANALISTANOTRESPOSTA (NRSEQSLA, NRNOTIFICATEMPORESP, NRPARCNEGOCIO, NRORG)
             VALUES (:NRSEQSLA,
                     :NRNOTIFICATEMPORESP,
                     :NRPARCNEGOCIO,
                     :NRORG)";
                    
            $params = array
            (
                "NRSEQSLA"              => $RESP['NRSEQSLA'],
                "NRNOTIFICATEMPORESP"   => $RESP['NRNOTIFICATEMPORESP'],
                "NRPARCNEGOCIO"         => $operador,
                "NRORG"                 => $RESP["NRORG"]
                );
    
            try
            {
                $std = $this->entityManager->getConnection()->prepare($insertResposta);
                $std->execute($params);
            }
            catch(\Exception $e)
            {
                $response->setError(new Error($e->getMessage(), $e->getCode()));
            };    
         }
        }
    }
    
    public function deleteOperNotResposta($RESP){
            $deleteOperResp =  "DELETE CRM_ANALISTANOTRESPOSTA
	                      WHERE NRNOTIFICATEMPORESP = :NRNOTIFICATEMPORESP
	                      AND NRSEQSLA              = :NRSEQSLA
	                      AND NRORG                 = :NRORG";
                    
            $params = array
            (
                "NRNOTIFICATEMPORESP"       => $RESP['NRNOTIFICATEMPORESP'],
                "NRSEQSLA"                  => $RESP['NRSEQSLA'],
                "NRORG"                     => $RESP["NRORG"]
                );
    
            try
            {
                $std = $this->entityManager->getConnection()->prepare($deleteOperResp);
                $std->execute($params);
            }
            catch(\Exception $e)
            {
                $response->setError(new Error($e->getMessage(), $e->getCode()));
            };  
    }
    
    public function saveOperNotResolucao($RESO){
        $operadores = $RESO['OPERADORESO'];

        if(count($operadores) > 0){
            foreach($operadores as $operador) {
            $insertResposta = "INSERT INTO CRM_ANALISTANOTRESOLUCAO (NRSEQSLA, NRNOTIFICATEMPORESO, NRPARCNEGOCIO, NRORG)
             VALUES (:NRSEQSLA,
                     :NRNOTIFICATEMPORESO,
                     :NRPARCNEGOCIO,
                     :NRORG)";
                    
            $params = array
            (
                "NRSEQSLA"              => $RESO['NRSEQSLA'],
                "NRNOTIFICATEMPORESO"   => $RESO['NRNOTIFICATEMPORESO'],
                "NRPARCNEGOCIO"         => $operador,
                "NRORG"                 => $RESO["NRORG"]
                );
    
            try
            {
                $std = $this->entityManager->getConnection()->prepare($insertResposta);
                $std->execute($params);
            }
            catch(\Exception $e)
            {
                $response->setError(new Error($e->getMessage(), $e->getCode()));
            };    
         }
        }
        
    }
    
    public function deleteOperNotResolucao($RESP){
            $deleteOperResp =  "DELETE CRM_ANALISTANOTRESOLUCAO
	                      WHERE NRNOTIFICATEMPORESO = :NRNOTIFICATEMPORESO
	                      AND NRSEQSLA              = :NRSEQSLA
	                      AND NRORG                 = :NRORG";
                    
            $params = array
            (
                "NRNOTIFICATEMPORESO"       => $RESP['NRNOTIFICATEMPORESO'],
                "NRSEQSLA"                  => $RESP['NRSEQSLA'],
                "NRORG"                     => $RESP["NRORG"]
                );
    
            try
            {
                $std = $this->entityManager->getConnection()->prepare($deleteOperResp);
                $std->execute($params);
            }
            catch(\Exception $e)
            {
                $response->setError(new Error($e->getMessage(), $e->getCode()));
            };  
    }
    
    public function saveOperResposta($RESP, $SLA){
        $operadores = $RESP['OPERADORESP'];
        
        if(count($operadores) > 0){
            foreach($operadores as $operador) {
            $insertResposta = "INSERT INTO CRM_ANALISTARESPOSTA (NRSEQSLA, NRREGRATEMPORESP, NRPARCNEGOCIO, NRORG)
             VALUES (:NRSEQSLA,
                     :NRREGRATEMPORESP,
                     :NRPARCNEGOCIO,
                     :NRORG)";
                    
            $params = array
            (
                "NRSEQSLA"          => $SLA,
                "NRREGRATEMPORESP"  => $RESP['NRREGRATEMPO'],
                "NRPARCNEGOCIO"     => $operador,
                "NRORG"             => $RESP["NRORG"]
                );
    
            try
            {
                $std = $this->entityManager->getConnection()->prepare($insertResposta);
                $std->execute($params);
            }
            catch(\Exception $e)
            {
                $response->setError(new Error($e->getMessage(), $e->getCode()));
            };    
         }
        }
        
    }
    
    public function deleteOperResposta($RESP, $SLA){

            $deleteOperResp =  "DELETE CRM_ANALISTARESPOSTA
	                    WHERE NRSEQSLA          = :NRSEQSLA
	                      AND NRREGRATEMPORESP  = :NRREGRATEMPO
	                      AND NRORG             = :NRORG";
                    
            $params = array
            (
                "NRSEQSLA"          => $RESP['NRSEQSLA'],
                "NRREGRATEMPO"      => $RESP['NRREGRATEMPO'],
                "NRORG"             => $RESP["NRORG"]
                );
    
            try
            {
                $std = $this->entityManager->getConnection()->prepare($deleteOperResp);
                $std->execute($params);
            }
            catch(\Exception $e)
            {
                $response->setError(new Error($e->getMessage(), $e->getCode()));
            };  
    }
    
    public function saveOperResolucao($SOLU, $SLA){
        $operadores = $SOLU['OPERADOSOLU'];
        if(count($operadores) > 0){
            foreach($operadores as $operador) {
            
        
                                                                        
           $insertOperResolucao = "INSERT INTO CRM_ANALISTARESOLUCAO (NRSEQSLA, NRREGRATEMPORESO, NRPARCNEGOCIO, NRORG)
             VALUES (:NRSEQSLA,
                     :NRREGRATEMPORESO,
                     :NRPARCNEGOCIO,
                     :NRORG)";
                    
            $params = array
            (
                "NRSEQSLA"          => $SLA,
                "NRREGRATEMPORESO"  => $SOLU['NRREGRATEMPOSOLU'],
                "NRPARCNEGOCIO"     => $operador,
                "NRORG"             => $SOLU["NRORG"]
                );
    
            try
            {
                $std = $this->entityManager->getConnection()->prepare($insertOperResolucao);
                $std->execute($params);
            }
            catch(\Exception $e)
            {
                $response->setError(new Error($e->getMessage(), $e->getCode()));
            };    
         }
        }
    }
    
    public function deleteOperResolucao($SOLU, $SLA){
 
            $deleteParcReso =  "DELETE CRM_ANALISTARESOLUCAO
	                    WHERE NRSEQSLA          = :NRSEQSLA
	                      AND NRREGRATEMPORESO  = :NRREGRATEMPOSOLU
	                      AND NRORG             = :NRORG";
                    
            $params = array
            (
                "NRSEQSLA"          => $SLA,
                "NRREGRATEMPOSOLU"      => $SOLU['NRREGRATEMPOSOLU'],
                "NRORG"             => $SOLU["NRORG"]
                );
    
            try
            {
                $std = $this->entityManager->getConnection()->prepare($deleteParcReso);
                $std->execute($params);
            }
            catch(\Exception $e)
            {
                $response->setError(new Error($e->getMessage(), $e->getCode()));
            };    
         }
    
    public function saveLembreteResposta(Request $request, Response $response){
        $dataset = $request->getDataSet()->getRows();
        $row = $dataset[0]['RESP'];
        
       
        $row['NRREGRATEMPO'] =  NovoCodigo::geraCodigo($this->environment->getNrOrgTrab(), "CRM_REGRATEMPORESP", 1, 10, false, false);
        $insertResposta = "INSERT INTO CRM_REGRATEMPORESP (NRSEQSLA, NRREGRATEMPORESP, NMREGRARESP, IDNOTIFICA, NRPERCENTRESP, NRORG)
         VALUES (:NRSEQSLA,
                 :NRREGRATEMPORESP,
                 :NMREGRARESP,
                 :IDNOTIFICA,
                 :NRPERCENTRESP,
                 :NRORG)";
                
        $params = array
        (
            "NRSEQSLA"          => $dataset[0]['SLA'],
            "NRREGRATEMPORESP"  => $row["NRREGRATEMPO"],
            "NMREGRARESP"       => $row["NMREGRA"],
            "IDNOTIFICA"        => $row["IDNOTIFICA"],
            "NRPERCENTRESP"     => $row["NRPERCENT"],
            "NRORG"             => $row["NRORG"]
            );

        try
        {
            $std = $this->entityManager->getConnection()->prepare($insertResposta);
            $std->execute($params);
            self::saveOperResposta($row, $dataset[0]['SLA']);
        }
        catch(\Exception $e)
        {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        };
    }
    
    public function saveLembreteResolucao(Request $request, Response $response){
        $dataset = $request->getDataSet()->getRows();
        $row = $dataset[0]['SOLU'];
       
        $row['NRREGRATEMPOSOLU'] =  NovoCodigo::geraCodigo($this->environment->getNrOrgTrab(), "CRM_REGRATEMPORESO", 1, 10, false, false);
                                                           
        $insertResolucao = "INSERT INTO CRM_REGRATEMPORESO (NRSEQSLA, NRREGRATEMPORESO, NMREGRASOLU, IDNOTIFICA, NRPERCENTSOLU, NRORG)
         VALUES (:NRSEQSLA,
                 :NRREGRATEMPORESO,
                 :NMREGRASOLU,
                 :IDNOTIFICA,
                 :NRPERCENTSOLU,
                 :NRORG)";
                
        $params = array
        (
            "NRSEQSLA"          => $dataset[0]['SLA'],
            "NRREGRATEMPORESO"  => $row["NRREGRATEMPOSOLU"],
            "NMREGRASOLU"       => $row["NMREGRASOLU"],
            "IDNOTIFICA"        => $row["IDNOTIFICASOLU"],
            "NRPERCENTSOLU"     => $row["NRPERCENTSOLU"],
            "NRORG"             => $row["NRORG"]
            );

        try
        {
            $std = $this->entityManager->getConnection()->prepare($insertResolucao);
            $std->execute($params);
            self::saveOperResolucao($row, $dataset[0]['SLA']);
        }
        catch(\Exception $e)
        {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        };
    }    
    
    public function saveLembrete(Request $request, Response $response) {
        $dataset = $request->getDataSet()->getRows();

        if(!empty($dataset[0]['RESP'])){
            self::saveLembreteResposta($request, $response);
        }
        
        if(!empty($dataset[0]['SOLU'])){
            self::saveLembreteResolucao($request, $response);
            
        }

        
    }
    
    public function deleteResposta(Row $row, Response $response){
        $lembrete = $row->getRow();
        $deleteResolucao = "DELETE CRM_REGRATEMPORESP
	                    WHERE NRSEQSLA = :NRSEQSLA
	                      AND NRREGRATEMPORESP = :NRREGRATEMPORESP
	                      AND NRORG            = :NRORG";

	        $params = array
	        (
	            "NRORG"             => $lembrete["NRORG"],
	            "NRSEQSLA"          => $lembrete["NRSEQSLA"],
	            "NRREGRATEMPORESP"  => $lembrete["NRREGRATEMPO"]
            );

	        try
	        {
	            $std = $this->connection->prepare($deleteResolucao);
	            $std->execute($params);
	        }catch (\Exception $e)
	        {
	            throw $e;
	        }
        
    }
    
    public function deleteResolucao(Row $row, Response $response){
        $lembrete = $row->getRow();
        $deleteResolucao = "DELETE CRM_REGRATEMPORESO
	                    WHERE NRSEQSLA = :NRSEQSLA
	                      AND NRREGRATEMPORESO = :NRREGRATEMPORESO
	                      AND NRORG            = :NRORG";

	        $params = array
	        (
	            "NRORG"             => $lembrete["NRORG"],
	            "NRSEQSLA"          => $lembrete["NRSEQSLA"],
	            "NRREGRATEMPORESO"  => $lembrete["NRREGRATEMPOSOLU"]
            );

	        try
	        {
	            $std = $this->connection->prepare($deleteResolucao);
	            $std->execute($params);
	        }catch (\Exception $e)
	        {
	            throw $e;
	        }
        
    }
    
    public function deleteRespostaNoti(Row $row, Response $response){
        $lembrete = $row->getRow();
        if(!empty($lembrete["OPERADORESP"])){
            self::deleteOperNotResposta($lembrete);
        }
           
        $deleteResolucao = "DELETE CRM_NOTIFICATEMPORESP
	                    WHERE NRSEQSLA          = :NRSEQSLA
	                      AND NRNOTIFICATEMPORESP  = :NRNOTIFICATEMPORESP
	                      AND NRORG             = :NRORG";

	        $params = array
	        (
	            "NRORG"                 => $lembrete["NRORG"],
	            "NRSEQSLA"              => $lembrete["NRSEQSLA"],
	            "NRNOTIFICATEMPORESP"   => $lembrete["NRNOTIFICATEMPORESP"]
            );

	        try
	        {
	            $std = $this->connection->prepare($deleteResolucao);
	            $std->execute($params);
	        }catch (\Exception $e)
	        {
	            throw $e;
	        }
        
    }
    
    public function deleteResolucaoNoti(Row $row, Response $response){
        $lembrete = $row->getRow();
        // var_dump($lembrete);die();
        
        if(!empty($lembrete["OPERADORESO"])){
            self::deleteOperNotResolucao($lembrete);
        }
        $deleteResolucao = "DELETE CRM_NOTIFICATEMPORESO
	                    WHERE NRSEQSLA              = :NRSEQSLA
	                      AND NRORG                 = :NRORG
	                      AND NRNOTIFICATEMPORESO   = :NRNOTIFICATEMPORESO";

	        $params = array
	        (
	            "NRORG"             => $lembrete["NRORG"],
	            "NRSEQSLA"          => $lembrete["NRSEQSLA"],
	            "NRNOTIFICATEMPORESO"  => $lembrete["NRNOTIFICATEMPORESO"]
            );

	        try
	        {
	            $std = $this->connection->prepare($deleteResolucao);
	            $std->execute($params);
	        }catch (\Exception $e)
	        {
	            throw $e;
	        }
        
    }
    
    public function deleteLembrete(Row $row, Response $response) {
    	$lembrete = $row->getRow();
	
        if($lembrete["TIPOREGRA"] == "RESOLUCAO"){
	        self::deleteResolucao($row, $response);
	      }
	      
	   if($lembrete["TIPOREGRA"] == "RESPOSTA"){
	        self::deleteResposta($row, $response);
	      }
          
    	}
    	
    public function deleteNotificacao(Row $row, Response $response) {
    	$lembrete = $row->getRow();
	
        if($lembrete["TIPOREGRA"] == "RESOLUCAO"){
	        self::deleteResolucaoNoti($row, $response);
	      }
	      
	   if($lembrete["TIPOREGRA"] == "RESPOSTA"){
	        self::deleteRespostaNoti($row, $response);
	      }
          
    	}	
    	
    public function updateResposta(Row $row, Response $response){
        $rowResposta = $row->getRow();
        
        $updateResposta = "UPDATE CRM_REGRATEMPORESP
                      SET IDNOTIFICA        = :IDNOTIFICA,
                          NMREGRARESP       = :NMREGRARESP,
                          NRPERCENTRESP     = :NRPERCENTRESP
                    WHERE NRSEQSLA          = :NRSEQSLA
                      AND NRREGRATEMPORESP  = :NRREGRATEMPORESP 
                      AND NRORG             = :NRORG";

        $params = array
        (
            "NRSEQSLA"          => $rowResposta["NRSEQSLA"],
            "NRREGRATEMPORESP"  => $rowResposta["NRREGRATEMPO"],
            "NRORG"             => $rowResposta["NRORG"],
            "IDNOTIFICA"        => $rowResposta["IDNOTIFICA"],
            "NMREGRARESP"       => $rowResposta["NMREGRA"],
            "NRPERCENTRESP"     => $rowResposta["NRPERCENT"]
        );

        try {
            $std = $this->connection->prepare($updateResposta);
            $std->execute($params);
            self::deleteOperResposta($rowResposta, $rowResposta['NRSEQSLA']);
            self::saveOperResposta($rowResposta, $rowResposta['NRSEQSLA']);
        }
        catch (\Exception $e) {
            throw $e;
        }
        
    }	
    
    public function updateResolucao(Row $row, Response $response){
        $rowResolucao = $row->getRow();
      
        $updateResolucao = "UPDATE CRM_REGRATEMPORESO
                      SET IDNOTIFICA        = :IDNOTIFICA,
                          NMREGRASOLU       = :NMREGRASOLU,
                          NRPERCENTSOLU     = :NRPERCENTSOLU
                    WHERE NRSEQSLA          = :NRSEQSLA
                      AND NRREGRATEMPORESO  = :NRREGRATEMPORESO 
                      AND NRORG             = :NRORG";

        $params = array
        (
            "NRSEQSLA"          => $rowResolucao["NRSEQSLA"],
            "NRREGRATEMPORESO"  => $rowResolucao["NRREGRATEMPOSOLU"],
            "NRORG"             => $rowResolucao["NRORG"],
            "IDNOTIFICA"        => $rowResolucao["IDNOTIFICASOLU"],
            "NMREGRASOLU"       => $rowResolucao["NMREGRASOLU"],
            "NRPERCENTSOLU"     => $rowResolucao["NRPERCENTSOLU"]
        );
        try {
            $std = $this->connection->prepare($updateResolucao);
            $std->execute($params);
            self::deleteOperResolucao($rowResolucao, $rowResolucao['NRSEQSLA']);
            self::saveOperResolucao($rowResolucao, $rowResolucao['NRSEQSLA']);
        }
        catch (\Exception $e) {
            throw $e;
        }
        
    }
    
    public function updateRespostaNotificacao(Row $row, Response $response){
        $rowResposta = $row->getRow();
        
        $updateRespostaNoti = "UPDATE CRM_NOTIFICATEMPORESP
                      SET IDNOTIFICARESP            = :IDNOTIFICARESP,
                          NMNOTIFICARESP            = :NMNOTIFICARESP,
                          IDNOTIFICAIMEDIATORESP    = :IDNOTIFICAIMEDIATORESP,
                          NRMINNOTIFICARESP         = :NRMINNOTIFICARESP
                    WHERE NRSEQSLA              = :NRSEQSLA
                      AND NRNOTIFICATEMPORESP   = :NRNOTIFICATEMPORESP 
                      AND NRORG                 = :NRORG";

        $params = array
        (
            "NRSEQSLA"                  => $rowResposta["NRSEQSLA"],
            "NRNOTIFICATEMPORESP"       => $rowResposta["NRNOTIFICATEMPORESP"],
            "NRORG"                     => $rowResposta["NRORG"],
            "IDNOTIFICARESP"            => $rowResposta["IDNOTIFICARESP"],
            "NMNOTIFICARESP"            => $rowResposta["NMNOTIFICARESP"],
            "IDNOTIFICAIMEDIATORESP"    => $rowResposta["IDNOTIFICAIMEDIATORESP"],
            "NRMINNOTIFICARESP"         => $rowResposta["NRMINNOTIFICARESP"]
        );

        try {
            $std = $this->connection->prepare($updateRespostaNoti);
            $std->execute($params);
            self::deleteOperNotResposta($rowResposta);
            self::saveOperNotResposta($rowResposta);
        }
        catch (\Exception $e) {
            throw $e;
        }
        
    }	
    
    public function updateResolucaoNotificacao(Row $row, Response $response){
        $rowResolucao = $row->getRow();
      
        $updateResolucao = "UPDATE CRM_NOTIFICATEMPORESO
                      SET IDNOTIFICARESO            = :IDNOTIFICARESO,
                          NMNOTIFICARESO            = :NMNOTIFICARESO,
                          IDNOTIFICAIMEDIATORESO    = :IDNOTIFICAIMEDIATORESO,
                          NRMINNOTIFICARESO         = :NRMINNOTIFICARESO
                      WHERE NRNOTIFICATEMPORESO = :NRNOTIFICATEMPORESO 
                      AND NRSEQSLA              = :NRSEQSLA
                      AND NRORG                 = :NRORG";

        $params = array
        (
            "NRSEQSLA"                  => $rowResolucao["NRSEQSLA"],
            "NRNOTIFICATEMPORESO"       => $rowResolucao["NRNOTIFICATEMPORESO"],
            "NRORG"                     => $rowResolucao["NRORG"],
            "IDNOTIFICARESO"            => $rowResolucao["IDNOTIFICARESO"],
            "NMNOTIFICARESO"            => $rowResolucao["NMNOTIFICARESO"],
            "IDNOTIFICAIMEDIATORESO"    => $rowResolucao["IDNOTIFICAIMEDIATORESO"],
            "NRMINNOTIFICARESO"         => $rowResolucao["NRMINNOTIFICARESO"]
        );
        try {
            $std = $this->connection->prepare($updateResolucao);
            $std->execute($params);
            self::deleteOperNotResolucao($rowResolucao);
            self::saveOperNotResolucao($rowResolucao);
        }
        catch (\Exception $e) {
            throw $e;
        }
        
    }
    
    public function saveNotificacaoResposta(Request $request, Response $response){
        $dataset = $request->getDataSet()->getRows();
        $row = $dataset[0]['RESP'];
       
        $row['NRNOTIFICATEMPORESP'] =  NovoCodigo::geraCodigo($this->environment->getNrOrgTrab(), "CRM_NOTIFICATEMPORESP", 1, 10, false, false);
                                                             
        $insertResposta = "INSERT INTO CRM_NOTIFICATEMPORESP (NRSEQSLA, NRNOTIFICATEMPORESP, NMNOTIFICARESP, IDNOTIFICARESP, IDNOTIFICAIMEDIATORESP, NRMINNOTIFICARESP, NRORG)
         VALUES (:NRSEQSLA,
                 :NRNOTIFICATEMPORESP,
                 :NMNOTIFICARESP,
                 :IDNOTIFICARESP,
                 :IDNOTIFICAIMEDIATORESP,
                 :NRPERCENTRESP,
                 :NRORG)";
                

        $params = array
        (
            "NRSEQSLA"                  => $row['NRSEQSLA'],
            "NRNOTIFICATEMPORESP"       => $row["NRNOTIFICATEMPORESP"],
            "NMNOTIFICARESP"            => $row["NMNOTIFICARESP"],
            "IDNOTIFICARESP"            => $row["IDNOTIFICARESP"],
            "IDNOTIFICAIMEDIATORESP"    => $row["IDNOTIFICAIMEDIATORESP"],
            "NRPERCENTRESP"             => $row["NRMINNOTIFICARESP"],
            "NRORG"                     => $row["NRORG"]
            );

        try
        {
            $std = $this->entityManager->getConnection()->prepare($insertResposta);
            $std->execute($params);
            self::saveOperNotResposta($row);
        }
        catch(\Exception $e)
        {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        };
    }
    
    public function saveNotificacaoResolucao(Request $request, Response $response){
          $dataset = $request->getDataSet()->getRows();
        $row = $dataset[0]['SOLU'];
       
        $row['NRNOTIFICATEMPORESO'] =  NovoCodigo::geraCodigo($this->environment->getNrOrgTrab(), "CRM_NOTIFICATEMPORESO", 1, 10, false, false);
        
        $insertResolucao = "INSERT INTO CRM_NOTIFICATEMPORESO (NRSEQSLA, NRNOTIFICATEMPORESO, NMNOTIFICARESO, IDNOTIFICAIMEDIATORESO, NRMINNOTIFICARESO, IDNOTIFICARESO,NRORG)
         VALUES (:NRSEQSLA,
                 :NRNOTIFICATEMPORESO,
                 :NMNOTIFICARESO,
                 :IDNOTIFICAIMEDIATORESO,
                 :NRMINNOTIFICARESO,
                 :IDNOTIFICARESO,
                 :NRORG)";
                

        $params = array
        (
            "NRSEQSLA"                  => $row['NRSEQSLA'],
            "NRNOTIFICATEMPORESO"       => $row["NRNOTIFICATEMPORESO"],
            "NMNOTIFICARESO"            => $row["NMNOTIFICARESO"],
            "IDNOTIFICAIMEDIATORESO"    => $row["IDNOTIFICAIMEDIATORESO"],
            "NRMINNOTIFICARESO"         => $row["NRMINNOTIFICARESO"],
            "IDNOTIFICARESO"            => $row["IDNOTIFICARESO"],
            "NRORG"                     => $row["NRORG"]
            );

        try
        {
            $std = $this->entityManager->getConnection()->prepare($insertResolucao);
            $std->execute($params);
            self::saveOperNotResolucao($row);
        }
        catch(\Exception $e)
        {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        };
    }

    public function saveNotificacao(Request $request, Response $response){
        $dataset = $request->getDataSet()->getRows();

        if(!empty($dataset[0]['RESP'])){
            self::saveNotificacaoResposta($request, $response);
        }
        
        if(!empty($dataset[0]['SOLU'])){
            self::saveNotificacaoResolucao($request, $response);
            
        }
        
    }


}





