<?php
namespace Teknisa\CRM\Geral\Repository;

use Doctrine\DBAL\Connection;

class EnviarMensagemRepository {

    protected  $connection;
    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }

    /**
     * @return array
     */
    public function getEstruturaProcesso($nrorgEstru, $nrprocesso) {
        $estruturaQuery = "SELECT NVL(NMFANTASIA, NMESTRUTURAM) NMFANTASIA, NMPROCESSO 
                            FROM DES_PROCESSO P 
                            JOIN ESTRUTURAM E
                              ON P.NRESTRUTGEREN = E.NRESTRUTURAM
                            JOIN ESTRUTURAH H
                              ON E.NRESTRUTURAM = H.NRESTRUTURAM
                           WHERE (NRPROCESSO = '$nrprocesso')  AND (P.NRORG = '$nrorgEstru')";
        return $this->connection->fetchAll($estruturaQuery);
    }

    public function getOperador($nrorg, $cdoperador) {
        $operadorQuery = "SELECT NMOPERADOR, DSEMAILOPER FROM OPERADOR O
                              JOIN PARCNEGOCIO P 
                                ON O.NRPARCNEGOCIO = P.NRPARCNEGOCIO 
                               AND O.NRORG = P.NRORG
                            WHERE CDOPERADOR = '$cdoperador' AND O.NRORG = '$nrorg' ";
                            
        return $this->connection->fetchAll($operadorQuery);
    }
    
    public function getInterlocutor($nrorg, $nrseqinterlocutor) {
        $interlocutorParcnegocioQuery = "SELECT
                                           NMINTERLOCUTOR,
                                           EMAILINTERLOC
                                         FROM
                                           CRM_INTERLOCUTOR INTER
                                           JOIN PARCNEGOCIO PARC ON PARC.NRPARCNEGOCIO = INTER.NRPARCNEGOCIO
                                                                  AND PARC.NRORG = INTER.NRORG
                                         WHERE
                                           INTER.NRSEQINTERLOCUTOR = '$nrseqinterlocutor'
                                           AND INTER.NRORG = '$nrorg'";
                                             
        return $this->connection->fetchAll($interlocutorParcnegocioQuery);  
    }

    public function getDadosInterlocutor($nrorg, $nrparcnegocio){
        $interlocutorParcnegocioQuery = "SELECT 
                                            NMINTEPROS AS NMOPERADOR,
                                            DSEMAILIPROS AS DSEMAILOPER 
                                          FROM 
                                            INTEPROSP IP
                                            JOIN RELACIONAPARC RP ON IP.NRRELACIONAPARC = RP.NRRELACIONAPARC
                                                                   AND IP.NRORG = RP.NRORG
                                            WHERE 
                                              RP.NRPARCNEGRELAC = '$nrparcnegocio' 
                                              AND IP.NRORG = '$nrorg' ";
                                             
        return $this->connection->fetchAll($interlocutorParcnegocioQuery);    
    }
    
    public function getLogoCliente($nrorg, $cdoperador) {
        $estruturamSelect = "SELECT DSURLLOGOESTRUTURA
                                FROM ESTRUTURAM EST
                                    LEFT JOIN OPERADOR OPE
                                        ON EST.NRESTRUTURAM = OPE.NRESTRUTTRAB
                                            AND EST.NRORG = OPE.NRORG
                                WHERE OPE.CDOPERADOR = '$cdoperador'
                                    AND OPE.NRORG = '$nrorg' ";
        return $this->connection->fetchAll($estruturamSelect);
    }
    
    public function getOperadorParcnegocio($nrorg, $nrparcnegocio) {
        $operadorParcnegocioQuery = "SELECT DISTINCT INITCAP(O.NMOPERADOR) NMOPERADOR, O.DSEMAILOPER
                         FROM OPERADOR O
                         JOIN PARCNEGOCIO P
                           ON O.NRPARCNEGOCIO = P.NRPARCNEGOCIO
                        WHERE (O.NRPARCNEGOCIO = '$nrparcnegocio') AND (O.NRORG = '$nrorg')";
        return $this->connection->fetchAll($operadorParcnegocioQuery);
    }

    public function getOperadorVinculo($nrorg, $nrvinculom) {
        $operadorVinculoQuery = "SELECT INITCAP(OP.NMOPERADOR) NMOPERADOR, OP.DSEMAILOPER 
                                   FROM GPE_VINCULOM VM
                                   JOIN GPE_PESSOA P
                                     ON P.NRPESSOA = VM.NRPESSOA
                                    AND P.NRORG = VM.NRORG
                                   JOIN OPERADOR OP
                                     ON OP.NRPARCNEGOCIO = P.NRPARCNEGOCIO
                                    AND OP.NRORG = P.NRORG
                                  WHERE VM.NRORG = '$nrorg' 
                                    AND VM.NRVINCULOM = '$nrvinculom'";
        $result = $this->connection->fetchAll($operadorVinculoQuery);

        if (empty($result)) {
           $result = self::getEmailComunicacao($nrorg, $nrvinculom);
        }                            

        return $result;
    }

     public function getEmailComunicacao($nrorg, $nrvinculom) {
        $operadorVinculoQuery = "SELECT CDCOMUNICAPARC, NMPRINCIPALPARC
                                   FROM COMUNICAPARC 
                                   JOIN PARCNEGOCIO
                                     ON PARCNEGOCIO.NRPARCNEGOCIO = COMUNICAPARC.NRPARCNEGOCIO
                                    AND PARCNEGOCIO.NRORG         = COMUNICAPARC.NRORG
                                  WHERE COMUNICAPARC.NRPARCNEGOCIO IN (SELECT NRPARCNEGOCIO 
                                                            FROM GPE_VINCULOM
                                                            JOIN GPE_PESSOA
                                                              ON GPE_PESSOA.NRPESSOA = GPE_VINCULOM.NRPESSOA
                                                             AND GPE_PESSOA.NRORG    = GPE_VINCULOM.NRORG
                                                           WHERE GPE_PESSOA.NRORG = '$nrorg'
                                                             AND NRVINCULOM       = '$nrvinculom') 
                                    AND COMUNICAPARC.CDFORMACOMU = '05' AND COMUNICAPARC.NRORG = '$nrorg'";
            
        return $this->connection->fetchAll($operadorVinculoQuery);
     }
     
     public function getOperadorSuperior($email, $nrorg){
        $bossQuery = "SELECT BOSS.NMOPERADOR, BOSS.DSEMAILOPER 
                                          FROM OPERADOR OP
                                           JOIN CRM_HIERARQUIAOPER HI
                                                ON OP.CDOPERADOR = HI.CDOPERADOR
                                                 AND OP.NRORG = HI.NRORG
                                            JOIN CRM_HIERARQUIAOPER HIBOSS
                                                ON HIBOSS.NRHIERARQUIAOPER = HI.NRHIERARQUIAPAI
                                                AND HIBOSS.NRORG = HI.NRORG
                                            JOIN OPERADOR BOSS
                                                ON BOSS.CDOPERADOR = HIBOSS.CDOPERADOR
                                                AND BOSS.NRORG = HIBOSS.NRORG
                                            WHERE OP.DSEMAILOPER = '$email' 
                                             AND OP.NRORG = '$nrorg'";
                                             
        return $this->connection->fetchAll($bossQuery);    
    }

} 

