/* Tabela ITCOMISSAO*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela ITCOMISSAO */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela ITCOMISSAO, utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_EXP_ITCOMISSAO
AFTER DELETE OR INSERT OR UPDATE
ON ITCOMISSAO FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_GRAV_DESC    VARCHAR2(300);
  V_DESC         VARCHAR2(2000);
  V_LENGTH       FLOAT(10);
  V_CONT_LENGTH FLOAT(10);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_NRINCREST    VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
  V_CDFILLOGOPER VARCHAR2(4);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   V_GRAV_DESC    := '';
   V_LENGTH       := '';
   V_CONT_LENGTH  := 1;
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_NRINCREST    := '';
   V_IDTIPOOPER   := '';
   V_CDFILLOGOPER := '';

   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

      IF INSERTING THEN

         IF :NEW.CDFILIAL IS NOT NULL THEN
            V_DESC := V_DESC || 'Filial = ' || NVL(:NEW.CDFILIAL,'') || ' ';
         END IF;
         IF :NEW.CDCOMISSAO IS NOT NULL THEN
            V_DESC := V_DESC || 'Tabela de Comisso = ' || NVL(:NEW.CDCOMISSAO,'') || ' ';
         END IF;
         IF :NEW.CDPRODUTO IS NOT NULL THEN
            V_DESC := V_DESC || 'Produto = ' || NVL(:NEW.CDPRODUTO,'') || ' ';
         END IF;
         IF :NEW.VRINICVENDA IS NOT NULL THEN
            V_DESC := V_DESC || 'Faixa Inicial = ' || NVL(:NEW.VRINICVENDA,'') || ' ';
         END IF;
         IF :NEW.VRFINAVENDA IS NOT NULL THEN
            V_DESC := V_DESC || 'Faixa Final = ' || NVL(:NEW.VRFINAVENDA,'') || ' ';
         END IF;         
         IF :NEW.VRPECOMIVEND IS NOT NULL THEN
            V_DESC := V_DESC || 'Comisso = ' || NVL(:NEW.VRPECOMIVEND,'') || '% ';
         END IF;

         V_ITPESQ     := :NEW.CDFILIAL || :NEW.CDCOMISSAO || :NEW.CDPRODUTO || :NEW.VRINICVENDA;
         V_IDTIPOOPER := '1';

   ELSE

      IF UPDATING THEN

         IF :NEW.CDFILIAL IS NOT NULL THEN
            V_DESC := V_DESC || 'Filial = ' || NVL(:NEW.CDFILIAL,'') || ' ';
         END IF;
         IF :NEW.CDCOMISSAO IS NOT NULL THEN
            V_DESC := V_DESC || 'Tabela de Comisso = ' || NVL(:NEW.CDCOMISSAO,'') || ' ';
         END IF;
         IF :NEW.CDPRODUTO IS NOT NULL THEN
            V_DESC := V_DESC || 'Produto = ' || NVL(:NEW.CDPRODUTO,'') || ' ';
         END IF;
         IF :NEW.VRINICVENDA IS NOT NULL THEN
            V_DESC := V_DESC || 'Faixa Inicial = ' || NVL(:NEW.VRINICVENDA,'') || ' ';
         END IF;
         IF :NEW.VRFINAVENDA IS NOT NULL THEN
            V_DESC := V_DESC || 'Faixa Final = ' || NVL(:NEW.VRFINAVENDA,'') || ' ';
         END IF;         
         IF :NEW.VRPECOMIVEND IS NOT NULL THEN
            V_DESC := V_DESC || 'Comisso = ' || NVL(:NEW.VRPECOMIVEND,'') || '% ';
         END IF;

         V_ITPESQ     := :NEW.CDFILIAL || :NEW.CDCOMISSAO || :NEW.CDPRODUTO || :NEW.VRINICVENDA;
         V_IDTIPOOPER := '2';

      END IF;

      IF DELETING  THEN

         IF :OLD.CDFILIAL IS NOT NULL THEN
            V_DESC := V_DESC || 'Filial = ' || NVL(:OLD.CDFILIAL,'') || ' ';
         END IF;
         IF :OLD.CDCOMISSAO IS NOT NULL THEN
            V_DESC := V_DESC || 'Tabela de Comisso = ' || NVL(:OLD.CDCOMISSAO,'') || ' ';
         END IF;
         IF :OLD.CDPRODUTO IS NOT NULL THEN
            V_DESC := V_DESC || 'Produto = ' || NVL(:OLD.CDPRODUTO,'') || ' ';
         END IF;
         IF :OLD.VRINICVENDA IS NOT NULL THEN
            V_DESC := V_DESC || 'Faixa Inicial = ' || NVL(:OLD.VRINICVENDA,'') || ' ';
         END IF;
         IF :OLD.VRFINAVENDA IS NOT NULL THEN
            V_DESC := V_DESC || 'Faixa Final = ' || NVL(:OLD.VRFINAVENDA,'') || ' ';
         END IF;         
         IF :OLD.VRPECOMIVEND IS NOT NULL THEN
            V_DESC := V_DESC || 'Comisso = ' || NVL(:OLD.VRPECOMIVEND,'') || '% ';
         END IF;

         V_ITPESQ     := :OLD.CDFILIAL || :OLD.CDCOMISSAO || :OLD.CDPRODUTO || :OLD.VRINICVENDA;
         V_IDTIPOOPER := '3';

      END IF;
   END IF;

   IF NOT (V_DESC IS NULL) THEN

      V_LENGTH := LENGTH(V_DESC);

      WHILE V_LENGTH >= V_CONT_LENGTH LOOP

         V_GRAV_DESC := SUBSTR(V_DESC, V_CONT_LENGTH, 300);
         V_CONT_LENGTH := V_CONT_LENGTH + 300;

         INSERT INTO LOGOPERA ( NMTABELA,     DTOPERACAO,   NMRESPOPER,
                                IDTIPOOPER,   DSOPERACAO,   CDPESQITEM,
                                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                                DSMETUSUOPER, CDORESPOPER,  CDFILLOGOPER)
                       VALUES  ('ITCOMISSAO', SYSDATE,    NVL(V_NMOPERADOR,' '),
                                V_IDTIPOOPER,   V_GRAV_DESC,    V_ITPESQ,
                                V_DSSERVERRDM,  V_DSREMOTEADDR, V_DSREMOTEHOST,
                                V_DSSERVMETHOD, V_DSREMOTEOPER, V_CDFILLOGOPER);

      END LOOP;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_EXP_ITCOMISSAO','5.85.xxx'); END;
/
