var CRM_Interlocutor_Controller = function(ScreenService, Utilities, General, Endereco, templateManager, CRM_Utilities, restEngine) {
    
    this.interlocutorOnEnterOnce = function(widget) {
        var filterRow = {};
        var fieldsToApply = ['IDATIVO'];
        
        CRM_Utilities.openFilterOnEnter(widget, filterRow, fieldsToApply);
    };
    
    this.filtraParcNegocio = function(widget) {
        var tipo = widget.getField('CDTIPOPARCPRINCIPAL');
        var parcnegocio = widget.getField('NRPARCNEGOCIO') ? widget.getField('NRPARCNEGOCIO') : widget.getField('NMPRINCIPALPARC');
        parcnegocio.value(null);
        if(tipo.value()) {
            parcnegocio.dataSourceFilter[0].value = tipo.value();
        } else {
            parcnegocio.dataSourceFilter[0].value = "@['CANDIDATO', 'PROSPECT', 'CLIENTE']@";
        }
        parcnegocio.reload();
    };
    
    this.backInterloc = function(args) {
        args.owner.widget.getAction('buscaCEP').isVisible = false;
        ScreenService.closeSwipe();
        args.owner.widget.list()
    };
    
    this.editInterloc = function(parentWidget) {
        parentWidget.getAction('buscaCEP').isVisible = true;
        General.edit(parentWidget);
    };
    
    this.cancelEditInterloc = function(args) {
        args.owner.widget.getAction('buscaCEP').isVisible = false;
        General.backOrCancel(args);
    };
    
    this.salvarInterloc = function(widget) {
        var currentRow = widget.currentRow;
        if(currentRow.NRCPFINTERLOC && currentRow.NRCPFINTERLOC != null) //Se o CPF estiver preenchido
        currentRow.NRCPFINTERLOC = currentRow.NRCPFINTERLOC.replace(/\D/g,''); //Tira os caracteres não-numéricos do CPF
        
        var paramsRestEngine = {
            "requestType": "Row",
            "row": widget.currentRow
        };
        restEngine.post('/crm_interlocutor/save', paramsRestEngine).then(function() {
            //ScreenService.closeSwipe();
            widget.getAction('buscaCEP').isVisible = true;
            widget.view();
            widget.reload();
        });
    };
    
    this.searchCountry = function() {
        var widget = templateManager.container.getActiveWidget();
        var pais = widget.getField('NMPAIS');
        var estado = widget.getField('NMESTADO');
        var municipio = widget.getField('NMMUNICIPIO');
        var bairro = widget.getField('NMBAIRRO');
        var paramsToSearch = [
            widget.currentRow.CDPAIS,
            widget.currentRow.SGESTADO,
            widget.currentRow.CDMUNICIPIO,
            widget.currentRow.CDBAIRRO
        ];
        if(!Util.isEmptyOrBlank(widget.currentRow.CDPAIS)) {
            restEngine.post('/searchCountry', {'requestType':'FilterData', paramsToSearch}).then(function(response) {
                if(response.dataset && response.dataset.dados){
                    widget.currentRow.NMPAIS = response.dataset.dados[0].NMPAIS;
                    if(!Util.isEmptyOrBlank(widget.currentRow.SGESTADO)) {
                        widget.currentRow.NMESTADO = response.dataset.dados[0].NMESTADO;
                        if(!Util.isEmptyOrBlank(widget.currentRow.CDMUNICIPIO)) {
                            widget.currentRow.NMMUNICIPIO = response.dataset.dados[0].NMMUNICIPIO;
                            if(!Util.isEmptyOrBlank(widget.currentRow.CDBAIRRO)) {
                                widget.currentRow.NMBAIRRO = response.dataset.dados[0].NMBAIRRO;
                            }
                        }
                    }
                }
            });
        }
    };
    
};

Configuration(function (ContextRegister) {
    ContextRegister.register('CRM_Interlocutor_Controller', CRM_Interlocutor_Controller);
});