function Dashboard_Controller(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, CRM_Utilities, ZHPromise, ZhFilterPreferences) {
    this.startDashboard = function(args) {
        if(templateManager.LOGGEDOPERATOR) {
            this.reloadWidgets(args);
            this.setVisibleDashboardTabs();
        }
    };
    
    this.reloadWidgets = function(args) {
        var container = args.owner;
        var widgets = container.widgets;
        widgets.forEach(function(widget) {
            widget.reload();
        });
    };
    
    this.setVisibleDashboardTabs = function() {
        var tabbed = templateManager.container.getWidget('tabbed');
        var tabForcaVendas = templateManager.container.getWidget('tabForcaVendas');
        var tabSAC = templateManager.container.getWidget('tabSAC');
        var IDEXIBEPAINELATEND = templateManager.LOGGEDOPERATOR.IDEXIBEPAINELATEND;
        var IDEXIBEPAINELVENDAS = templateManager.LOGGEDOPERATOR.IDEXIBEPAINELVENDAS;
        var whoIsVisible = '';

        if (IDEXIBEPAINELVENDAS !== 'N') {
            tabForcaVendas.isVisible = true;
            whoIsVisible = 'vendas';
        }
        //Comentado para manter a aba "Atendimento ao Cliente" invisível devido a mudanças no sistema.
        /*if (IDEXIBEPAINELATEND !== 'N') {
            tabSAC.isVisible = true;
            if (Util.isEmptyOrBlank(whoIsVisible))
                whoIsVisible = 'sac';
            else
                whoIsVisible = 'both';
        }*/

        this.getActiveTabs(whoIsVisible).then(function(response) {
            setTimeout(function() {
                response.activeWidget.activate();
            }.bind(this), 500);
        });

    };

    this.getActiveTabs = function(whoIsVisible) {
        var tabbed = templateManager.container.getWidget('tabbed');
        var tabForcaVendas = templateManager.container.getWidget('tabForcaVendas');
        var tabSAC = templateManager.container.getWidget('tabSAC');
        var zhPromise = ZHPromise.defer();

        switch (whoIsVisible) {
            case 'sac':
                tabbed.currentWidget = tabSAC;
                tabSAC.active = true;
                tabForcaVendas.active = false;
                break;

            case 'vendas':
                tabbed.currentWidget = tabForcaVendas;
                tabForcaVendas.active = true;
                tabSAC.active = false;
                break;

            case 'both':
                tabbed.currentWidget = tabForcaVendas;
                tabForcaVendas.active = true;
                tabSAC.active = false;
                break;

            default:
                tabbed.isVisible = false;
                zhPromise.resolve({
                    "activeWidget": tabbed
                });
        }

        zhPromise.resolve({
            "activeWidget": tabbed.currentWidget
        });

        return zhPromise.promise;
    };

    this.setDimensions = function(container) {
        var widgets = container.widgets;
        if (window.innerWidth < 929) {
            widgets.forEach(function(widget) {
                widget.dimensions.width = 4.5;
                widget.width = 4.5;
            });
        }
    };

    this.openOpportunityWidgetWithoutFilterPopup = function() {

        ScreenService.openWindow('product#crm00002_001_oportunidade_de_negocio').then(function() {

            var oportWid = templateManager.container.getWidget('oportunidadegrid');
            
            oportWid.fromDashboard = true;
            
            var filtroAberto = [
                {
                    "name": "P_NRORG",
                    "operator": "=",
                    "value": templateManager.LOGGEDOPERATOR.NRORG    
                },
                {
                    "name": "CRM_NRORGTRAB",
                    "operator": "=",
                    "value": getLocalVar('CRM_NRORGTRABALHO')    
                },
                {
                    "name": "SITUACAO",
                    "operator": "=",
                    "value": "A"    
                },
                {
                    "name": "NRPARCRESP",
                    "operator": "IN",
                    "value": [templateManager.LOGGEDOPERATOR.NRPARCNEGOCIO]
                },
                {
                    "name": "IDTPOPERADOR",
                    "operator": "=",
                    "value": Util.isEmptyOrBlank(templateManager.LOGGEDOPERATOR.IDTPOPERADOR) ? 'E' : templateManager.LOGGEDOPERATOR.IDTPOPERADOR
                }
            ];
            
            oportWid.dataSourceFilter = filtroAberto;
            oportWid.reload().then(function() {
                ScreenService.closePopup(true);
            });

        });

    };

    this.loadDataSources = function(widget) {
        if (widget.isVisible) {
            if (!Util.isEmptyOrBlank(widget.widgets)) {
                widget.widgets.forEach(function(inWidget) {
                    this.loadDataSources(inWidget);
                }.bind(this));
            }
            widget.reload();
        }
    };

    this.openChamadoWidgetWithoutFilterPopup = function() {

        ScreenService.openWindow('product#crm_20000_chamado').then(function() {

            var chamadoWidgt = templateManager.container.getWidget('WDGT_CHAMADO');
            chamadoWidgt.dataSourceFilter = [
                {
                    name: "STATUS",
                    operator: "=",
                    static: true,
                    value: "Aberto"
                },
                {
                    name: "CDOPERCONT",
                    operator: "IN",
                    static: true,
                    value: [templateManager.LOGGEDOPERATOR.CDOPERADOR]
                }
            ]
            chamadoWidgt.reload().then(function() {
                ScreenService.closePopup(true);
            });

        });

    };

    this.changeColorBarFunil = function(name) {
        $(document).ready(function() {
            var element = angular.element(name);
            element.find("g.bars").each(function(index, element) {
                //Declarando outra variavel de index para evitar perder o index do 'each'
                var indexColor = index;

                var colors = [
                        "#7ad2e8",
                        "#57b0cc",
                        "#3f95af",
                        "#3288a3",
                        "#1b6077",
                        "#0c3c4f",
                        "#052b3a",
                        "#011f2d",
                        "#001119",
                        "#00090f"
                    ];

                //Se houver mais barras do que cores no array colors, continua pegando a última
                if (typeof colors[indexColor] === "undefined")
                    indexColor = colors.length - 1;

                $(this).find("rect").attr("fill", colors[indexColor]);
                $(this).find("text").attr("fill", colors[indexColor]);
            });
        });
    };

    this.changeColorTerm = function(name, widget) {
        $(document).ready(function() {
            var element = angular.element(name);
            var data = widget.dataSource.data;
            element.find("g.slices .slice").each(function(index, element) {
                $(this).attr("fill", data[index]['CORTERMOMETRO']);
                $(this).attr("fill", data[index]['CORTERMOMETRO']);
            });
            element.find("g.slices .label-value").each(function(index, element) {
                $(this).attr("fill", data[index]['CORTERMOMETRO']);
                $(this).attr("fill", data[index]['CORTERMOMETRO']);
            });
            element.find('.legend-label path').each(function(index, element) {
                $(this).attr("fill", data[index]['CORTERMOMETRO']);
                $(this).attr("fill", data[index]['CORTERMOMETRO']);
            });
        });
    };

    this.openChartTermByOper = function(widget) {
        var mes = widget.currentRow.ORDEM;
        var operadores = templateManager.LOGGEDOPERATOR.CDOPERSHIERARQINF;

        ScreenService.openWindow('product#crm_indicadorTermometro').then(function() {

            this.getColors().then(function(termometro) {
                var nameTermometro = termometro.map(function(t) {
                    return t['NMTERMOPORTUNI'];
                });

                var widgetChart = templateManager.container.getWidget('WDGT_INDICADOR_TERMOMETRO');

                if (!Util.isEmptyOrBlank(widgetChart.chartSeries[0].serieFields)) {
                    widgetChart.chartSeries[0].serieFields = [];
                    widgetChart.chartSeries[0].serieLabels = [];
                    widgetChart.chartSeries[0].serieColors = [];
                }
                termometro.forEach(function(t) {
                    widgetChart.chartSeries[0].serieFields.push("'" + t['NMTERMOPORTUNI'] + "'");
                    widgetChart.chartSeries[0].serieLabels.push(t['NMTERMOPORTUNI']);
                    widgetChart.chartSeries[0].serieColors.push(t['DSCORHEXADECIMAL']);
                });
                widgetChart.chartSeries[0].serieFields.push("'SEMTERM'");
                widgetChart.chartSeries[0].serieLabels.push('Sem Termômetro');
                widgetChart.chartSeries[0].serieColors.push('#ddd');

                widgetChart.dataSourceFilter = [
                    {
                        name: "P_NRORG",
                        operator: "=",
                        static: true,
                        value: templateManager.LOGGEDOPERATOR.NRORG
                    },
                    {
                        name: "P_NRPARCOPERSHIERARQINF",
                        operator: "IN",
                        static: true,
                        value: templateManager.LOGGEDOPERATOR.NRPARCOPERSHIERARQINF
                    },
                    {
                        name: "P_COLORS",
                        operator: "=",
                        static: true,
                        value: nameTermometro
                    },
                    {
                        name: "P_CRM_NRORGTRAB",
                        operator: "=",
                        static: true,
                        value: getLocalVar('CRM_NRORGTRABALHO')
                    }
                ];
                var stripe = templateManager.container.getWidget('WDGT_INDICADOR_STRIPE');
                stripe.fields[0].label = 'Termômetro de Oportunidades';
                stripe.activate();
                widget.activate();
                widgetChart.reload();
                widgetChart.updateChart();
            });
        }.bind(this));
    };

    this.getColors = function() {
        var filter = [
            {
                "name": "NRORG",
                "operator": "=",
                "value": templateManager.LOGGEDOPERATOR.NRORG
            }
        ];
        return localStorageEngine.download("product#/crud/crm_termoportuni", filter);
    };
    
    this.openChartMetaByOper = function(widget, chart) {
        var mes = widget.currentRow.ORDEM;
        var operadores = templateManager.LOGGEDOPERATOR.CDOPERSHIERARQINF;

        ScreenService.openWindow('product#crm_indicadorMeta').then(function() {

            var widgetChart = this.chooseWidgetChart(chart);

            widgetChart.dataSourceFilter = [
                {
                    name: "P_NRORG",
                    operator: "=",
                    static: true,
                    value: templateManager.LOGGEDOPERATOR.NRORG
                },
                {
                    name: "P_CDOPERSHIERARQINF",
                    operator: "IN",
                    static: true,
                    value: operadores
                },
                {
                    name: "ORDEM",
                    operator: "=",
                    static: true,
                    value: mes.slice(0,2)
                }
            ];
            widgetChart.currentRow['MES'] = mes;
            widgetChart.currentRow['ORDEM'] = widget.currentRow.ORDEM;
            var stripe = templateManager.container.getWidget('WDGT_INDICADOR_STRIPE');
            stripe.fields[0].label = widgetChart.label;
            //Replace pra pegar o ano no LocaleString
            stripe.fields[1].label = new Date(mes.replace('/', '/01/')).toLocaleString('pt-BR', {month:'long', year:'numeric'});
            stripe.fields[1].label = CRM_Utilities.capitalizeFirstLetter(stripe.fields[1].label);
            stripe.chart = chart;
            widget.activate();
            widgetChart.reload();

        }.bind(this));
    };

    this.chooseWidgetChart = function(chart) {
        var widget;
        switch (chart) {
            case 'valor_oportunidades':
                widget = templateManager.container.getWidget('WDGT_INDICADOR_VALOR');
                widget.isVisible = true;
                templateManager.container.getWidget('WDGT_INDICADOR_CONVERSAO').isVisible = false;
                break;

            case 'conversao_leads':
                widget = templateManager.container.getWidget('WDGT_INDICADOR_CONVERSAO');
                widget.isVisible = true;
                templateManager.container.getWidget('WDGT_INDICADOR_VALOR').isVisible = false;
                break;
                
            case 'leads_cadastrados_convertidos':
                widget = templateManager.container.getWidget('WDGT_TAB_INDICADORLEAD');
                widget.isVisible = true;
                break;
            
        }
        return widget;
    };
    
    this.openChartLeadsByOper = function(widget) {
        var mes = widget.currentRow.ORDEM;

        ScreenService.openWindow('product#crm_indicadorLeads').then(function() {

            var widgetChart = templateManager.container.getWidget('WDGT_TAB_INDICADORLEAD');
            widgetChart.ORDEM = mes;
            
        }.bind(this));
    };
    
    this.getOperatorPropertyIfSetted = function(propertyName) {
        var operatorInfos = templateManager.LOGGEDOPERATOR;
        
        if(operatorInfos) {
            return operatorInfos[propertyName];
        } else {
            return '';
        }
    };
    
    this.openTarefasWindow = function() {
        ScreenService.openWindow('product#crm31000_000_agenda_de_tarefas').then(function() {
            var widget = templateManager.container.getWidget('Agenda');
            var filtroAberto = [
            {
                "name": "NRORG",
                "operator": "=",
                "value": templateManager.LOGGEDOPERATOR.NRORG    
            },
            {
                "name": "CRM_NRORGTRAB",
                "operator": "=",
                "value": getLocalVar('CRM_NRORGTRABALHO')    
            },
            {
                name: "P_CDOPERLOGADO",
                operator: "=",
                value: getLocalVar('CRM_CDOPERADOR')
            },
            {
                "name": "STATUS_PRINCIPAL",
                "operator": "IN",
                "value": ["ATRASADA", "HOJE", "FUTURA"]
            },
            {
                "name": "CDOPERREAL",
                "operator": "IN",
                "value": [templateManager.LOGGEDOPERATOR.CDOPERADOR]
            }];
            
            widget.dataSourceFilter = filtroAberto;
            widget.reload().then(function() {
                setTimeout(function() {
                    ScreenService.closePopup(true);
                }, 500);
            });
        });
    };
    
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Dashboard_Controller', Dashboard_Controller);
});
