function RelatorioDiasSemEvolucaoController(General, templateManager, CRM_Utilities) {
    
    this.defaultFilter = function(widget){
        /* 
         * Os campos CDSETOR E CDDEPTO serão visíveis no filtro apenas
         *  se o NRORG for igual a 20.
         */
        var showCodes = templateManager.LOGGEDOPERATOR.NRORG == '20';
        var filterCDSETOR = widget.getField('NMSETOR').filterProperties;
        var filterCDDEPTO = widget.getField('NMDEPTO').filterProperties;
        
        /* 
         * Os dois atributos de ambos os campos possuem o mesmo valor booleano,
         *  que está em showCodes.
         */
        filterCDSETOR.isVisible = filterCDSETOR.isVisibleOnReport
            = filterCDDEPTO.isVisible = filterCDDEPTO.isVisibleOnReport = showCodes;
    };
    
    this.readOnlySetor = function(widget){
        var depto = widget.getField('CDDEPTO');
        var setor = widget.getField('CDSETOR');
        
        if(Util.isEmptyOrBlank(depto.value())){
            setor.readOnly = true;
            setor.clearValue();
        }else{
            setor.readOnly = false;
            setor.clearValue();
        }
        
    };
    
    this.defaultValueInterval = function() {
        var newDefault = {};
        
        var year  = moment().format('YYYY');
        var month = moment().format('MM');
        var day   = moment().format('DD');
       
        var dateStart = '01/' + month.toString() + '/' + year;
        var dateEnd   = day +'/'+ month.toString() + '/' + year;
        
        newDefault.start = dateStart;
        newDefault.end = dateEnd;
        newDefault.period = undefined;
        
        return newDefault;
    };
    
    this.filtraOposta = function(nmWidget, widget){
        
        widget.getParent().widgets.forEach(function(wid){
        	if(wid.name != nmWidget){
        		wid.filtra = true;
        	}
        });
         
        widget.filtra = false;
        widget.getParent().currentFilter =  widget.dataSourceFilter;
    };
    
    this.verificaFiltro = function(nmWidget, widget){
       
       if(widget.getParent().currentFilter){
           if(widget.dataSourceFilter != widget.getParent().currentFilter){
                widget.dataSourceFilter = widget.getParent().currentFilter;
                widget.reload();
                widget.filtra = false;
           }
       }
         
    };
}
Configuration(function(ContextRegister) {
    ContextRegister.register('RelatorioDiasSemEvolucaoController', RelatorioDiasSemEvolucaoController);
});
/* global moment Util Configuration */