var ZeedhiDirectives = angular.module("ZeedhiDirectives");

ZeedhiDirectives.directive('zhForm', function(templateManager, eventAggregator, DeveloperToolsForm){
	return {
		link: function($scope, $element, $attributes, $controller){
			var preparedDependencies;

			function setInitialDependencieFieldsVisibility(valuesInForm){
				Object.keys(preparedDependencies.dependsOn).forEach(function(fieldName, algo){
					var field = $scope.widget.getField(fieldName);
					if(field){
						var expectedValues = {"invalids": []};
						var dependsOn = field.dependsOn;
						Object.keys(dependsOn).forEach(function(fieldDependName){
							expectedValues[fieldDependName] = dependsOn[fieldDependName];
							valuesInForm[fieldDependName] = valuesInForm[fieldDependName] === undefined ? false : valuesInForm[fieldDependName];
							if(dependsOn[fieldDependName] !== valuesInForm[fieldDependName]){
								field.isVisible = false;
								expectedValues.invalids.push(fieldDependName);
							}
						});
						field.expectedValues = expectedValues;
					}
				});
			}

			function setJsonValuesInFields(jsonItem){
				var valuesInForm = {};
				$scope.widget.fields.forEach(function(field){
					var fieldName = field.name;
					var value = jsonItem[fieldName];
					if((!DeveloperToolsForm.hasPropertyInJson(jsonItem, fieldName) && field.hasOwnProperty("defaultValue"))){
						value = field.defaultValue;
					} else if(DeveloperToolsForm.isCheckboxField(field.template)){
						field.saveValue = value;
						value = !!field.saveValue;
					}
					field.value(value);
					valuesInForm[fieldName] = value;
				});
				if(preparedDependencies.dependsOn){
					setInitialDependencieFieldsVisibility(valuesInForm);
				}
			}

			function createFormWidgetAndContainer(fields, docTemplate, jsonItem){
				var formAndContainer = DeveloperToolsForm.getFormWidgetAndContainer(fields, docTemplate, jsonItem, preparedDependencies);
				$scope.formWidget = formAndContainer.widget;
				$scope.widget = formAndContainer.widget;
				$scope.templateManager.container = formAndContainer.container;
				if(jsonItem){
					setJsonValuesInFields(jsonItem);
				}
			}
			$scope.createFormWidgetAndContainer = createFormWidgetAndContainer;

			var getDocAndCreateForm = Util.buildDebounceMethod(function(item){
				var jsonItem = item;
				DeveloperToolsForm.getFormDocTemplate(jsonItem.template).then(function(docTemplate){
					if(docTemplate){
						DeveloperToolsForm.getFormDocTemplate(jsonItem.template, true).then(function(options){
							var keysConcat = Object.keys(jsonItem).concat(Object.keys(docTemplate.properties));
							preparedDependencies = DeveloperToolsForm.getFormDependencies(docTemplate.dependencies, options);
							keysConcat = keysConcat.filter(function(value, valueIndex) {
								return keysConcat.indexOf(value) == valueIndex && value != 'template';
							});
							createFormWidgetAndContainer(keysConcat, docTemplate, jsonItem, preparedDependencies);
						});
					}
				});
			}, 200, true);

			function updateFieldsOfDependency(fieldChanged){
				var fieldChangedName = fieldChanged.name;
				fieldChanged.dependencieFields.forEach(function(fieldName){
					var dependencieField = $scope.widget.getField(fieldName);
					if(dependencieField){
						var expectedValues = dependencieField.expectedValues;
						var invalidValues = expectedValues.invalids;
						var fieldIndexInInvalids = invalidValues.indexOf(fieldChangedName);
						var hasFieldInInvalids = fieldIndexInInvalids >= 0;
						var fieldValueIsValid = fieldChanged.value() === expectedValues[fieldChangedName];
						if(fieldValueIsValid && fieldChanged.isVisible){
							if(hasFieldInInvalids){
								invalidValues.splice(fieldIndexInInvalids, 1);
							}
						} else if(!hasFieldInInvalids){
							invalidValues.push(fieldChangedName);
						}
						dependencieField.isVisible = !invalidValues.length;
						if(dependencieField.dependencieFields){
							updateFieldsOfDependency(dependencieField);
						}
					}
				});
			}

			eventAggregator.subscribe('creatingForm', function(item){
				getDocAndCreateForm(item);
			});

			eventAggregator.subscribe('updateDependencyFieldsVisibility', function(widgetAndFields){
				updateFieldsOfDependency(widgetAndFields);
			});
		}
	};
});